/*
 ============================================================================
 Project     : Parallel Memetic Algorithm
 Author      : Lucas Angelo Silveira
 Universidade de Brasilia (UnB) - Brazil
 Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: February 01, 2016.
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "ParalellMA.h"
#include <mpi.h>
#include <time.h>//time

#define DIETAG 2
#define DEBUG 0

int main(int argc,char **argv)
{
    int myid, proc, numprocs;
    struct timeval start, end;
    float tmili=0.0;
    
    //double wtime;
    unsigned int seed = time(NULL);
	srand (seed);//initialize random generator
    
    MPI_Init(&argc,&argv);
    MPI_Comm_rank(MPI_COMM_WORLD,&myid);
    MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
    
    if(myid == 0)
    {
        gettimeofday(&start, NULL);
        
        master();
        
        //Tell all the slaves to exit by sending an empty message with the DIETAG.
        for (proc = 1; proc<numprocs; proc++){
            MPI_Send(0, 0, MPI_BYTE, proc, DIETAG, MPI_COMM_WORLD);
        }
        if (DEBUG) printf("... all the slaves died*\n");
        
        gettimeofday(&end, NULL);
        tmili = (float) (1000.0 * (end.tv_sec - start.tv_sec) + (end.tv_usec - start.tv_usec) / 1000.0);
        
        printf("time:%.2f seconds\n", (tmili/1000.0));
    }
    else{
        
        slave();
        
    }
    MPI_Finalize();
    
    //printf(" ...process %d Finalized\n",myid);
    
    return 0;
}//end main


